#include <Tools/DateTime.mqh>

class DataT{
public:
    DataT(){};
    ~DataT(){};

    int difDatas(MqlDateTime& dt1, MqlDateTime& dt2);

    bool datasDiferentes(MqlDateTime& dt1, MqlDateTime& dt2);
    //Data 1 é menor que data 2?
    bool dataMenor(MqlDateTime& dt1, MqlDateTime& dt2);

    //--- Se o dia da semana é maior que o data atual, a semana virou
    //--- Se o dia da semana é menor ou igual a data atual e a já se passaram 7 dias ou mais, a semana virou
    bool semanaAnterior(MqlDateTime& dt1, MqlDateTime& dt2);

    bool mesAnterior(MqlDateTime& dt1, MqlDateTime& dt2);

    void zeroHora(MqlDateTime& data);
    void ultimaHora(MqlDateTime& data);

    datetime inicioDiaAtual();
    datetime fimDiaAtual();

    datetime dMenos(int menos);
    datetime dMenos(datetime data, int menos);
    datetime dMenos(MqlDateTime& data, int menos);

    datetime inicioDMenos(int menos);
    datetime fimDMenos(int menos);
};

int DataT::difDatas(MqlDateTime& dt1, MqlDateTime& dt2){
    if(dt1.mon == dt2.mon){
        return dt2.day - dt1.day;
    }else{
        CDateTime dateDt1;
        dateDt1.Date(dt1);
        int diasDt1 = dateDt1.DaysInMonth() - dt1.day;

        if((dt1.mon + 1) != dt2.mon){
            dateDt1.Mon(dt1.mon+1);
            for(dateDt1.mon; dateDt1.mon < dt2.mon; dateDt1.Mon(dateDt1.mon+1)){
                diasDt1 += dateDt1.DaysInMonth();
            }
        }
        return diasDt1 + dt2.day;
    }
}

bool DataT::datasDiferentes(MqlDateTime& dt1, MqlDateTime& dt2){
    if(dt1.day != dt2.day || dt1.mon != dt2.mon || dt1.year != dt2.year)
        return true;
    return false;
}

bool DataT::dataMenor(MqlDateTime& dt1, MqlDateTime& dt2){
    if(dt1.day < dt2.day || dt1.mon < dt2.mon || dt1.year < dt2.year)
        return true;
    return false;
}

bool DataT::semanaAnterior(MqlDateTime& dt1, MqlDateTime& dt2){
    if(dt1.day_of_week > dt2.day_of_week || (dt1.day_of_week <= dt2.day_of_week && (difDatas(dt1, dt2) >= 7)))
        return true;
    return false;
}

bool DataT::mesAnterior(MqlDateTime& dt1, MqlDateTime& dt2){
    if(dt1.mon < dt2.mon || dt1.year < dt2.year)
        return true;
    return false;
}

void DataT::zeroHora(MqlDateTime& data){
    data.hour = 0;
    data.min = 0;
    data.sec = 0;
}

void DataT::ultimaHora(MqlDateTime& data){
    data.hour = 23;
    data.min = 59;
    data.sec = 59;
}

datetime DataT::inicioDiaAtual(){
    MqlDateTime dia;
    TimeLocal(dia);
    zeroHora(dia);
    return StructToTime(dia);
}

datetime DataT::fimDiaAtual(){
    MqlDateTime dia;
    TimeLocal(dia);
    ultimaHora(dia);
    return StructToTime(dia);
}

datetime DataT::dMenos(datetime data, int menos){
    CDateTime dataDif;
    TimeToStruct(data, dataDif);
    //Subtrai os dias da data passada
    dataDif.Day(dataDif.day - menos);
    return StructToTime(dataDif);
}

datetime DataT::dMenos(MqlDateTime& data, int menos){
    return dMenos(StructToTime(data), menos);
}

datetime DataT::dMenos(int menos){
    return dMenos(TimeLocal(), menos);
}

datetime DataT::inicioDMenos(int menos){
    MqlDateTime dia;
    TimeToStruct(dMenos(menos), dia);
    zeroHora(dia);
    return StructToTime(dia);
}

datetime DataT::fimDMenos(int menos){
    MqlDateTime dia;
    TimeToStruct(dMenos(menos), dia);
    ultimaHora(dia);
    return StructToTime(dia);
}